
local ADDONNAME = "Finklestein"


local printpre = ADDONNAME..":"
local function print(...)
	_G.print(printpre, ...)
end

local mapCont, mapZone  -- determined when we speak to finklestein

local Astrolabe = DongleStub("Astrolabe-0.4")

local fetch = {
	["Interface\\Icons\\INV_Misc_Food_49"] = {
		["y"] = 0.5285993814468384,
		["x"] = 0.3492644131183624,
	},
	["Interface\\Icons\\INV_DataCrystal05"] = {
		["y"] = 0.5343273878097534,
		["x"] = 0.3486670851707459,
	},
	["Interface\\Icons\\INV_Potion_57"] = {
		["y"] = 0.5121142268180847,
		["x"] = 0.3477264642715454,
	},
	["Interface\\Icons\\INV_Egg_02"] = {
		["y"] = 0.5123577117919922,
		["x"] = 0.347713828086853,
	},
	["Interface\\Icons\\INV_Misc_MonsterScales_03"] = {
		["y"] = 0.5155376195907593,
		["x"] = 0.3497003614902496,
	},
	["Interface\\Icons\\INV_Potion_03"] = {
		["y"] = 0.5096887946128845,
		["x"] = 0.34903684258461,
	},
	["Interface\\Icons\\INV_Potion_11"] = {
		["y"] = 0.5100402235984802,
		["x"] = 0.3504683673381805,
	},
	["Interface\\Icons\\INV_Egg_04"] = {
		["y"] = 0.5100345015525818,
		["x"] = 0.350958913564682,
	},
	["Interface\\Icons\\INV_Misc_Bone_02"] = {
		["y"] = 0.5095914006233215,
		["x"] = 0.3485483229160309,
	},
	["Interface\\Icons\\INV_Misc_Herb_07"] = {
		["y"] = 0.5153501629829407,
		["x"] = 0.3499880135059357,
	},
	["Interface\\Icons\\INV_Cask_01"] = {
		["y"] = 0.5140703320503235,
		["x"] = 0.347625195980072,
	},
	["Interface\\Icons\\INV_Misc_MonsterClaw_02"] = {
		["y"] = 0.5096127986907959,
		["x"] = 0.3489223420619965,
	},
	["Interface\\Icons\\INV_DataCrystal06"] = {	-- Blight Crystal
		["y"] = 0.53472512960434,
		["x"] = 0.34879100322723,
	},
	["Interface\\Icons\\INV_Potion_126"] = {
		["y"] = 0.509619414806366,
		["x"] = 0.3490386009216309,
	},
	["Interface\\Icons\\Spell_Nature_NaturesWrath"] = {
		["y"] = 0.534432053565979,
		["x"] = 0.3484805822372437,
	},
	["Interface\\Icons\\Spell_Nature_Acid_01"] = {
		["y"] = 0.5341695547103882,
		["x"] = 0.3507634401321411,
	},
	["Interface\\Icons\\Ability_Creature_Poison_02"] = {
		["y"] = 0.5309064984321594,
		["x"] = 0.3473989367485046,
	},
	["Interface\\Icons\\INV_Misc_Fish_34"] = {
		["y"] = 0.5119125843048096,
		["x"] = 0.3506399095058441,
	},
	["Interface\\Icons\\INV_Potion_135"] = {
		["y"] = 0.5124367475509644,
		["x"] = 0.3477800786495209,
	},
	["Interface\\Icons\\INV_SummerFest_FirePotion"] = false,
	["Interface\\Icons\\INV_Misc_MonsterTail_03"] = {
		["y"] = 0.5131962299346924,
		["x"] = 0.3476704359054565,
	},
	["Interface\\Icons\\INV_Misc_Powder_Copper"] = {
		["y"] = 0.5117387771606445,
		["x"] = 0.3478161692619324,
	},
	["Interface\\Icons\\INV_Misc_Food_02"] = {
		["y"] = 0.515515923500061,
		["x"] = 0.3494667112827301,
	},
	["Interface\\Icons\\INV_Potion_109"] = {
		["y"] = 0.5337799787521362,
		["x"] = 0.3507266938686371,
	},
}

local frame = FinklesteinFrame or CreateFrame("Frame", "FinklesteinFrame")
frame:UnregisterAllEvents()


local oldunreg = frame.UnregisterEvent
function frame.UnregisterEvent(self, event)
	return oldunreg(self,event)
end

local dot=FinklesteinDot or CreateFrame("Frame", "FinklesteinDot")
dot:SetParent(Minimap)
dot:SetWidth(4)
dot:SetHeight(4)
dot.tx = dot:CreateTexture()
dot.tx:SetAllPoints(dot)
dot.tx:SetTexture(1,0.5,0.5)

frame:SetScript("OnEvent", function(self,event,...)
    return frame[event](self,event,...)
end)

local function testDone()
	if frame.endTime and GetTime() > frame.endTime then
		frame:UnregisterEvent("UNIT_AURA")
		frame:UnregisterEvent("MINIMAP_UPDATE_ZOOM")
		frame.endTime=nil
		Astrolabe:RemoveIconFromMinimap(dot)
		print("Deactivating")
	end
end


frame:SetScript("OnUpdate", function()
	frame:RegisterEvent("GOSSIP_SHOW")		-- If done at the root level (or in ADDON_LOADED), this randomly fails when on-demand loaded. I don't know why, so this is my hack around it.
	frame:Hide()
end)
frame:Show()

function frame:GOSSIP_SHOW()
	testDone()
	if tonumber(strsub(UnitGUID("target") or "", 9,12),16)==28205 then
		-- Hi, Finklestein!
		frame:RegisterEvent("GOSSIP_CONFIRM_CANCEL")
		frame:RegisterEvent("GOSSIP_CLOSED")
	end
end

function frame:GOSSIP_CLOSED()
	testDone()
	frame:UnregisterEvent("GOSSIP_CONFIRM_CANCEL")
	frame:UnregisterEvent("GOSSIP_CLOSED")
end

function frame:GOSSIP_CONFIRM_CANCEL()
	print("Starting")
	frame:RegisterEvent("UNIT_AURA")
	frame:RegisterEvent("MINIMAP_UPDATE_ZOOM")	-- happens when we leave the tomb
	frame:UnregisterEvent("GOSSIP_CONFIRM_CANCEL")
	frame:UnregisterEvent("GOSSIP_CLOSED")
	frame.endTime = GetTime()+10
	SetMapToCurrentZone();
	mapCont, mapZone = GetCurrentMapContinent(), GetCurrentMapZone();
end

function frame:MINIMAP_UPDATE_ZOOM()
	testDone()
end

local lookingFor = nil

function frame:UNIT_AURA(event,unit)
	if unit=="player" then
		for i=1,40 do
			local name, rank, iconTexture, count, debuffType, duration, timeLeft  =  UnitDebuff("player",i)
			if not name then break end
			local data = fetch[iconTexture]
			if data and rank=="" and count==0 and debuffType==nil then
				lookingFor = name
				frame:RunTipScanner()
				Astrolabe:PlaceIconOnMinimap(dot, mapCont, mapZone, data.x, data.y)
				frame.endTime = timeLeft+10
				return
			end
		end
		lookingFor = nil
		Astrolabe:RemoveIconFromMinimap(dot)
		frame:StopTipScanner()
		if frame.endTime > GetTime()+10 then
			frame.endTime = GetTime()+10
		end
	end

	testDone()
end



----------------------------------------------------------------
-- Ping cursor pos when mousing over the right item


local pingframe = _G[ADDONNAME.."PingFrame"] or CreateFrame("Model", ADDONNAME.."PingFrame")
pingframe:SetWidth(100)
pingframe:SetHeight(100)
pingframe:SetScale(0.5)

pingframe:SetFrameStrata("HIGH")

pingframe:SetModel("Interface\\Minimap\\ping\\minimapping.m2")

local Scale = UIParent:GetEffectiveScale();
local Hypotenuse = ( ( GetScreenWidth() * Scale ) ^ 2 + ( GetScreenHeight() * Scale ) ^ 2 ) ^ 0.5;

pingframe:SetPoint("TOPRIGHT", UIParent, "BOTTOMLEFT", 0,0)	-- dummy pos for getright/getleft etc to work
local width = ( pingframe:GetRight() - pingframe:GetLeft() ) / Hypotenuse; -- X
local height = ( pingframe:GetTop() - pingframe:GetBottom() ) / Hypotenuse; -- Y

pingframe:SetPosition(width/2, height/2, 0)	-- position the model in the middle of the frame

pingframe:Hide()

local lastx,lasty=0,0
pingframe:SetScript("OnUpdate", function(self, duration)
	local x,y=GetPlayerMapPosition("player")
	local alpha = self:GetAlpha()
	if x~=lastx or y~=lasty or IsMouselooking() then
		alpha = max(alpha-duration*7, 0)
		lastx=x
		lasty=y
	else
		alpha = max(alpha-duration*1.5, 0)
	end
	self:SetAlpha(alpha)
	if alpha<=0 then
		pingframe:Hide()
	end
end)

pingframe:SetScript("OnShow", function(self)
	self:SetAlpha(1)
	local x,y = GetCursorPosition()
	x = x / pingframe:GetScale()
	y = y / pingframe:GetScale()
	pingframe:ClearAllPoints()
	pingframe:SetPoint("CENTER", UIParent, "BOTTOMLEFT", x,y)
end)



local lasttip = nil
local function tipScanner(self)
	local tip = GameTooltipTextLeft1:GetText()
	if tip==lasttip then
		return
	end
	lasttip = tip
	if tip and strlen(tip)>=2 and lookingFor then
		if strfind(lookingFor, tip, 1, true) or 
		   strfind(lookingFor, strsub(tip, 1, -2), 1, true) -- try with last letter lopped off (works for plural "s" in english at least...)
		   then
			 pingframe:Show()
		end
	end
end

function frame:RunTipScanner()
	frame:SetScript("OnUpdate", tipScanner)
	frame:Show()
end

function frame:StopTipScanner()
	frame:Hide()
end


